; title picture
; the game itself is in a compressed executable comp.prg which is copied to place and jumped to when done

COLS = 22
ROWS = 23

!src "pic.asm"

k_device_num = $ba

colorram = $9400 + (vmatrix & $200)
charset0 = $1800
charset1 = $1000

k_getinkbd = $f1f9 ;$ffe4

copy_code = $100

* = $1240

entry:
    sei
    ldx #$ff
    txs

    ; disable screen
    lda #(((vmatrix & $200) >> 2) | 0)
    sta $9002
    lda #$08
    sta $900f

    ; copy colordata
    ldx #0
    ldy #0
-   lda colordata,x
    pha
    and #$f
colorcopy_h1 = * + 2
    sta colorram,y
    iny
    pla
    lsr
    lsr
    lsr
    lsr
colorcopy_h2 = * + 2
    sta colorram,y
    iny
    bne +
    inc colorcopy_h1
    inc colorcopy_h2
+   inx
    cpx #23 * 22 / 2
    bne -

display_loop:
    ; wait for line 0
-   lda $9004
    bne -

    ; change to charset 0
    lda #((((vmatrix & $1c00) >> 10) | ((vmatrix & $8000) >> 12) XOR 8) << 4) | (((charset0 & $1c00) >> 10) | ((charset0 & $8000) >> 12) XOR 8)
    sta $9005
    ; enable screen
    lda #(((vmatrix & $200) >> 2) | COLS)
    sta $9002

    ; run kernal keyscan
    jsr $ff9f
    ; check if any keys pressed
    jsr k_getinkbd
    bne display_done
    ; check if joystick fire pressed
    lda $9111
    and #$20
    beq display_done

!if YSPLIT > 0 {
    ; change charset at line $9001 + 8 * YSPLIT
    lda #YSPLIT * 8 / 2 - 1
    clc
    adc $9001
!set _PAGE_CROSS = *
-   cmp $9004
    bne -
!if (>_PAGE_CROSS) != (>*) {
!error "page cross at: ", _PAGE_CROSS
}
    ; delay for 2 lines - x cycles
    ; 220 / 194
    ldx #25
    lsr $ede4   ; C = 0 -> PAL, C = 1 -> NTSC
    bcc +
    ldx #29
+
!set _PAGE_CROSS = *
-   dex
    bne -
!if (>_PAGE_CROSS) != (>*) {
!error "page cross at: ", _PAGE_CROSS
}
    lda #((((vmatrix & $1c00) >> 10) | ((vmatrix & $8000) >> 12) XOR 8) << 4) | (((charset1 & $1c00) >> 10) | ((charset1 & $8000) >> 12) XOR 8)
    sta $9005
}
    jmp display_loop

display_done:
    lda #(((vmatrix & $200) >> 2) | 0)
    sta $9002

    ; setup copy code
    ldx #LEN_copy_code - 1
-   lda copy_code_start,x
    sta copy_code,x
    dex
    bpl -

    jmp copy_code

copy_code_start:
!pseudopc copy_code {
    ; copy forward to lower addr
--  ldy #0
-
copy_fwd_smc_srch = * + 2
    lda payload_start,y
copy_fwd_smc_dsth = * + 2
    sta 4621,y
    iny
    bne -
    inc copy_fwd_smc_dsth
    ldy copy_fwd_smc_srch
    iny
    sty copy_fwd_smc_srch
    cpy #>(payload_end + $100)
    bne --

copy_done:
    ; setup ae:af
    lda #<(payload_end - payload_start + 4621)
    sta $ae
    lda #>(payload_end - payload_start + 4621)
    sta $af
    jmp 4621
}
copy_code_end = *
LEN_copy_code = copy_code_end - copy_code_start

Code_end = *

* = $2000

payload_start:
!bin "comp.prg",,2 + 12
payload_end = *
